/* demos.gp */

\\zeta
L = lfuninit(1,[100]);
lfunlambda(L,2)
lfunlambda(L,-1)
lfunan(L,10)
lfun(L,2)
Pi^2/6
lfunzeros(L,20)
ploth(t=0,100,lfunhardy(L,t));

\\E: y^2 + y = x^3 + x^2 - 2*x
E = ellinit([0, 1, 1, -2, 0]);
N = ellglobalred(E)[1];
p = 1009;
L = lfuncreate(E);
lfunparams(L)
lfuneuler(L,p)
p+1 - ellcard(E,p)
lfun(L,1+x)
ellrank(E)
\\lfunshift(L,-1/2) has functional equation s <-> 1-s

M = mfinit([N,2],0);
mfdim(M)
B = mfeigenbasis(M);
f = B[1];
L2 = lfunmf(M,f);
lfunparams(L2)
lfunan(L,100) == lfunan(L2,100)

P = x^3 - x^2 - 2*x + 1;
K = nfinit(P);
L = lfuncreate(K);
lfunparams(L)
chi1 = Mod(2,7);
chi2 = Mod(4,7);
L2 = lfunmul(lfunmul(lfuncreate(chi1),lfuncreate(chi2)),lfuncreate(1));
lfunparams(L2)
lfunan(L,1000) == round(lfunan(L2,1000))

P = y^4 + 5*y^2 - y + 1;
K = bnfinit(P,1);
C = bnrinit(K,1);
C.cyc
chi1 = [1];
chi2 = [2];
L1 = lfunmul(lfuncreate([C,chi1]),lfuncreate([C,chi2]));
lfunparams(L1)
H = bnrclassfield(C,,2)
L2 = lfundiv(lfuncreate(H),lfuncreate(K));
lfunparams(L2)
round(lfunan(L1,1000)) == round(lfunan(L2,1000))

setrand(1);
P = a^4 - a^3 + 2*a^2 + 4*a + 3;
K = nfinit(P);
pr = idealprimedec(K,13)[1];
K = bnfinit(K,1);
G = gcharinit(K,pr);
G.cyc
chi = [2, -1, -1, 0, -1/2]~;
\\Laplace eigenvalue = 0 (harmonic)
Lchi = lfuncreate([G,chi]);
lfunparams(Lchi)

\\C: y^2 + x^3*y = -2*x^4 - 2*x^3 + 2*x^2 + 3*x - 2
\\https://www.lmfdb.org/Genus2Curve/Q/28561/a/371293/1
eqn = [-2*x^4 - 2*x^3 + 2*x^2 + 3*x - 2, x^3];
L = lfungenus2(eqn);
lfunparams(L)
factor(lfunparams(L)[1])
lfunan(L,1000) == round(lfunan(Lchi,1000))

P = x^4-5;
K = bnfinit(P,1);
G = gcharinit(K,1);
G.cyc
chi = [1,0,0,0]~;
\\- ( (I*phi1)^2 + (I*phi2)^2 - k3^2 + 4*(I*phi3)^2)
\\Laplace eigenvalue = 5.0631304...
L = lfuncreate([G,chi]);
lfunparams(L)
lfunparams(L)[3]*1.

\\ H: x4 = t*x1^5, x1+x2+x3+x4=0, xi!=0
H = hgminit([5]);
hgmgamma(H)
t = 1/64;
L = lfunhgm(H,t);
lfunparams(L)
lfuneuler(L,2)
lfuneuler(L,3)
lfuneuler(L,5)
lfuneuler(L,7)
lfuneuler(L,11)

